<?php
/*******************************************************************
 *			
 * 			Fichier			:	install.php 
 * 			Cr le			:	30 juillet 2002 
 * 			Dernire modif	:	01 juillet 2003 
 * 			Email			:	wascripts@phpcodeur.net 
 * 
 * 				Copyright  2002-2003 phpCodeur
 * 
 *******************************************************************/

/*******************************************************************
 *  This program is free software; you can redistribute it and/or 
 * 	modify it under the terms of the GNU General Public License as 
 * 	published by the Free Software Foundation; either version 2 of 
 *  the License, or (at your option) any later version. 
 *******************************************************************/


define('IN_INSTALL', true); 

require('./setup.inc.php'); 

$lang = $datetime = $msg_error = array(); 
$error = FALSE; 

$vararray = array('start', 'confirm', 'send_file'); 
foreach( $vararray AS $varname )
{
	${$varname} = ( isset($_POST[$varname]) ) ? true : false; 
}

$vararray = array(
	'language', 'prev_language', 'type', 'admin_login', 'admin_email', 'admin_pass', 
	'confirm_pass', 'urlsite', 'urlscript'
); 
foreach( $vararray AS $varname )
{
	${$varname} = ( !empty($_POST[$varname]) ) ? trim($_POST[$varname]) : ''; 
}

$confirm_pass 	= ( $confirm_pass != '' ) ? md5($confirm_pass) : ''; 
$language 		= ( $language != '' ) ? $language : $default_lang; 

if( isset($supported_db[$dbtype]) )
{
	include($waroot . 'sql/' . $dbtype . '.php'); 
}
else
{
	exit('<b>Le type de base de donnes n\'est pas dfini !</b>'); 
}

$template->set_filenames( array(
	'body' => 'install.tpl'
));	

if( $type != 'reinstall' && $type != 'update' )
{
	$type = 'install'; 
	
	if( $language != $prev_language )
	{
		$start = FALSE; 
	}
}

if( defined('NL_INSTALLED') )
{
	$db = new sql($dbhost, $dbuser, $dbpassword, $dbname);
	
	if( !$db->connect_id )
	{
		$error = true; 
		$msg_error[] = '<b>Impossible de se connecter  la base de donnes</b>'; 
	}
	
	$sql = "SELECT language, urlsite, path, version, hebergeur FROM " . CONFIG_TABLE; 
	if( !($result = $db->query($sql)) )
	{
		exit('<b>Impossible d\'obtenir la configuration du script</b>'); 
	}
	
	$old_config = $db->fetch_array($result); 
	
	$old_version = $old_config['version']; 
	$urlsite     = $old_config['urlsite']; 
	$urlscript   = $old_config['path']; 
	$language    = $old_config['language']; 
	$hebergeur   = $old_config['hebergeur']; 
	
	require($waroot . 'language/lang_' . $language . '.php'); 
	
	$login = FALSE; 
	
	if( $confirm )
	{
		$sql = "SELECT admin_email, admin_pwd, admin_level 
			FROM " . ADMIN_TABLE . " 
			WHERE LOWER(admin_login) = '" . strtolower($admin_login) . "'"; 
		if( $result = $db->query($sql) )
		{
			if( $row = $db->fetch_array($result) )
			{
				if( md5($admin_pass) == $row['admin_pwd'] && $row['admin_level'] == ADMIN )
				{
					$login        = TRUE; 
					$start        = TRUE; 
					$admin_email  = $row['admin_email']; 
					$confirm_pass = $row['admin_pwd']; 
				}
			}
		}
		
		if( !$login )
		{
			$error = TRUE; 
			$msg_error[] = $lang['Message']['Error_login']; 
		}
	}
	
	$template->assign_vars( array(
		'PAGE_TITLE'	=> $lang['Title']['reinstall_update'],
		'S_CHARSET'		=> $lang['CHARSET'],
		'NEW_VERSION'	=> $new_version,
		'TRANSLATE'		=> ( $lang['TRANSLATE'] != '' ) ? ' | Translate by ' . $lang['TRANSLATE'] : ''
	));	
	
	if( !$start || $error )
	{
		$template->assign_block_vars('reinstall', array(
			'L_EXPLAIN_REINSTALL'	=> nl2br($lang['Warning_reinstall']),
			'L_LOGIN'				=> $lang['Login'],
			'L_PASS'				=> $lang['Password'],
			'L_SELECT_TYPE'			=> $lang['Select_type'],
			'L_TYPE_REINSTALL'		=> $lang['Type_reinstall'],
			'L_TYPE_UPDATE'			=> $lang['Type_update'],
			'L_CONF_BUTTON'			=> $lang['Button']['conf']
		)); 
		
		if( $error )
		{
			$template->assign_block_vars('reinstall.error', array(
				'MSG_ERROR' => '<br /><ul type="square" class="mediumtexte"><li>' . implode('</li><li>', $msg_error) . '</li></ul>'
			)); 
		}
		
		$template->pparse('body'); 
		exit;
	}
}
else
{
	if( $start )
	{
		$db = new sql($dbhost, $dbuser, $dbpassword, $dbname);
		
		if( !$db->connect_id )
		{
			$error = TRUE; 
			$msg_error[] = '<b>Impossible de se connecter  la base de donnes</b>'; 
		}
	}
	else
	{
		if( !empty($_SERVER['HTTP_ACCEPT_LANGUAGE']) )
		{
			$accept_lg_ary = explode(',', $_SERVER['HTTP_ACCEPT_LANGUAGE']); 
			
			foreach( $accept_lg_ary AS $accept_lg )
			{
				$accept_lg = strtolower(substr(trim($accept_lg), 0, 2)); 
				
				if( isset($supported_lang[$accept_lg]) )
				{
					if( file_exists($waroot . 'language/lang_' . $supported_lang[$accept_lg] . '.php') )
					{
						$language = $supported_lang[$accept_lg]; 
					}
				}
			}
		}
	}
	
	include($waroot . 'language/lang_' . $language . '.php'); 
	
	$template->assign_vars( array(
		'PAGE_TITLE'  => $lang['Title']['install'],
		'S_CHARSET'   => $lang['CHARSET'],
		'NEW_VERSION' => $new_version,
		'TRANSLATE'   => ( $lang['TRANSLATE'] != '' ) ? ' | Translate by ' . $lang['TRANSLATE'] : ''
	));	
}

if( $send_file )
{
	include($waroot . 'includes/class.attach.php'); 
	
	Attach::send_file('config.inc.php', 'text/x-delimtext', $config_file); 
	
//	header('Content-Type: text/x-delimtext; name="config.inc.php"'); 
//	header('Content-disposition: attachment; filename=config.inc.php'); 
//	header('Content-Description: File Transfert'); 
//	header('Pragma: no-cache'); 
//	header('Expires: 0'); 
	
//	echo $config_file; 
	exit; 
}
else
{
	if( $start )
	{
		include($waroot . 'includes/functions.validate.php'); 
		
		if( $dbhost == '' || $dbname == '' || $dbuser == '' || $prefixe == '' || $admin_login == '' )
		{
			$error = TRUE; 
			$msg_error[] = $lang['Message']['fields_empty']; 
		}
		
		if( !preg_match('/^[[:alnum:]_-]{4,30}$/', $admin_pass) )
		{
			$error = TRUE; 
			$msg_error[] = $lang['Message']['Alphanum_pass']; 
		}
		else if( md5($admin_pass) != $confirm_pass )
		{
			$error = TRUE; 
			$msg_error[] = $lang['Message']['Bad_confirm_pass']; 
		}
		
		$resultat = check_email($admin_email); 
		
		if( $resultat['error'] )
		{
			$error = TRUE; 
			$msg_error[] = $resultat['message']; 
		}
		
		$urlsite = preg_replace('/^http(s)?:\/\/(.*?)\/?$/i', 'http\\1://\\2', $urlsite); 
		
		if( $urlscript != '/' )
		{
			$urlscript = preg_replace('/^\/?(.*?)\/?$/i', '/\\1/', $urlscript); 
		}
		
		//
		// On allonge le temps maximum d'execution du script. 
		//
		@set_time_limit(120); 
		
		if( ( $type == 'install' || $type == 'reinstall' ) && !$error )
		{
			$db->transaction(START_TRC); 
			
			if( $type == 'reinstall' )
			{
				$sql_drop = preg_replace('/wa_/', $prefixe, $sql_drop); 
				
				exec_queries($sql_drop); 
			}
			
			//
			// Cration des tables du script 
			//
			$sql_file = $schemas_dir . $supported_db[$dbtype]['prefixe_file'] . '_tables.sql'; 
			
			if( !($fp = @fopen($sql_file, 'r')) )
			{
				msg_result('sql_file_not_readable'); 
			}
			
			$sql_create = make_sql_ary(fread($fp, filesize($sql_file)), $supported_db[$dbtype]['delimiter'], $prefixe); 
			fclose($fp); 
			
			exec_queries($sql_create, true); 
			
			//
			// Insertion des donnes de base 
			//
			$sql_file = $schemas_dir . $supported_db[$dbtype]['prefixe_file'] . '_data.sql'; 
			
			if( !($fp = @fopen($sql_file, 'r')) )
			{
				msg_result('sql_file_not_readable'); 
			}
			
			$sql_data = make_sql_ary(fread($fp, filesize($sql_file)), $supported_db[$dbtype]['delimiter2'], $prefixe); 
			fclose($fp); 
			
			$sql_data[] = "UPDATE " . ADMIN_TABLE . " SET admin_login = '" . $admin_login . "', admin_pwd = '" . md5($admin_pass) . "', admin_email = '$admin_email', admin_lang = '$language' WHERE admin_id = 1"; 
			$sql_data[] = "UPDATE " . CONFIG_TABLE . " SET urlsite = '$urlsite', path = '$urlscript', language = '$language', mailing_startdate = " . time() . ", version = '$new_version'"; 
			$sql_data[] = "UPDATE " . LISTE_TABLE . " SET liste_startdate = " . time() . " WHERE liste_id = 1"; 
			
			exec_queries($sql_data, true); 
			
			$db->transaction(END_TRC); 
		}
		else if( $type == 'update' && !$error )
		{
			$sql_update = array(); 
			
			switch( $old_version )
			{
				case '2.2-Beta':
				case '2.2-Beta2':
					switch( DATABASE )
					{
						case 'mssql':
							$sql_update[] = "ALTER TABLE " . CONFIG_TABLE . "
								ALTER COLUMN [smtp_user] [varchar] (50) NOT NULL"; 
							$sql_update[] = "ALTER TABLE " . CONFIG_TABLE . "
								ALTER COLUMN [smtp_pass] [varchar] (50) NOT NULL"; 
							$sql_update[] = "ALTER TABLE " . LISTE_TABLE . " ADD 
								liste_alias varchar(250) NOT NULL, 
								use_cron smallint NOT NULL, 
								pop_host varchar(100) NOT NULL, 
								pop_port smallint NOT NULL, 
								pop_user varchar(50) NOT NULL, 
								pop_pass varchar(50) NOT NULL, 
								liste_alias varchar(250) NOT NULL, 
								CONSTRAINT [DF_" . LISTE_TABLE . "_use_cron] DEFAULT (0) FOR [use_cron], 
								CONSTRAINT [DF_" . LISTE_TABLE . "_pop_port] DEFAULT (110) FOR [pop_port]"; 
							break;
						
						case 'postgre':
							$sql_update[] = "ALTER TABLE " . CONFIG_TABLE . "
								RENAME COLUMN smtp_user TO smtp_user_old, 
								RENAME COLUMN smtp_pass TO smtp_pass_old"; 
							$sql_update[] = "ALTER TABLE " . CONFIG_TABLE . "
								ADD COLUMN smtp_user varchar(50) NOT NULL DEFAULT '', 
								ADD COLUMN smtp_pass varchar(50) NOT NULL DEFAULT ''"; 
							$sql_update[] = "UPDATE " . CONFIG_TABLE . " SET smtp_user = smtp_user_old, smtp_pass = smtp_pass_old"; 
							$sql_update[] = "ALTER TABLE " . LISTE_TABLE . " 
								ADD COLUMN liste_alias varchar(250) NOT NULL"; 
							$sql_update[] = "ALTER TABLE " . LISTE_TABLE . " 
								ALTER COLUMN liste_alias SET DEFAULT ''"; 
							$sql_update[] = "ALTER TABLE " . LISTE_TABLE . " 
								ADD COLUMN use_cron int NOT NULL"; 
							$sql_update[] = "ALTER TABLE " . LISTE_TABLE . " 
								ALTER COLUMN use_cron SET DEFAULT '0'"; 
							$sql_update[] = "ALTER TABLE " . LISTE_TABLE . " 
								ADD COLUMN pop_host varchar(100) NOT NULL"; 
							$sql_update[] = "ALTER TABLE " . LISTE_TABLE . " 
								ALTER COLUMN pop_host SET DEFAULT ''"; 
							$sql_update[] = "ALTER TABLE " . LISTE_TABLE . " 
								ADD COLUMN pop_port int2 NOT NULL"; 
							$sql_update[] = "ALTER TABLE " . LISTE_TABLE . " 
								ALTER COLUMN pop_port SET DEFAULT '110'"; 
							$sql_update[] = "ALTER TABLE " . LISTE_TABLE . " 
								ADD COLUMN pop_user varchar(50) NOT NULL"; 
							$sql_update[] = "ALTER TABLE " . LISTE_TABLE . " 
								ALTER COLUMN pop_user SET DEFAULT ''"; 
							$sql_update[] = "ALTER TABLE " . LISTE_TABLE . " 
								ADD COLUMN pop_pass varchar(50) NOT NULL"; 
							$sql_update[] = "ALTER TABLE " . LISTE_TABLE . " 
								ALTER COLUMN pop_pass SET DEFAULT ''"; 
							break;
						
						default:
							$sql_update[] = "ALTER TABLE " . CONFIG_TABLE . " 
								MODIFY COLUMN smtp_user varchar(50) NOT NULL DEFAULT '', 
								MODIFY COLUMN smtp_pass varchar(50) NOT NULL DEFAULT ''"; 
							$sql_update[] = "ALTER TABLE " . LISTE_TABLE . " 
								ADD COLUMN liste_alias varchar(250) NOT NULL DEFAULT '', 
								ADD COLUMN use_cron tinyint(1) NOT NULL DEFAULT '0',
								ADD COLUMN pop_host varchar(100) NOT NULL DEFAULT '',
								ADD COLUMN pop_port smallint(5) NOT NULL DEFAULT '110',
								ADD COLUMN pop_user varchar(50) NOT NULL DEFAULT '',
								ADD COLUMN pop_pass varchar(50) NOT NULL DEFAULT ''"; 
							break;
					}
					
					if( $hebergeur == 3 )
					{
						$sql_update[] = "UPDATE " . CONFIG_TABLE . " SET hebergeur = 1"; 
					}
				
				//
				// Un bug tait prsent dans la rc1, comme une seconde dition du package avait t mise 
				//  disposition pour pallier  un bug de dernire minute assez important, le numro de version 
				// tait 2.2-RC2 pendant une dizaine de jours (alors qu'il me semblait avoir recorrig 
				// le package aprs coup). 
				// Nous effectuons donc la mise  jour galement pour les versions 2.2-RC2. 
				// Le nom de la vrai release candidate 2 est donc 2.2-RC2b pour viter des problmes lors des mises 
				//  jour par les gens qui ont tlcharg le package les dix premiers jours.
				//
				case '2.2-RC1':
				case '2.2-RC2':
					//
					// Suppression des ventuelles entres orphelines dans les tables abonnes et abo_liste
					//
					$sql = "SELECT abo_id 
						FROM " . ABONNES_TABLE; 
					if( !($result = $db->query($sql)) )
					{
						msg_result($sql, true); 
					}
					
					$abonnes_id = array(); 
					while( $row = $db->fetch_array($result) )
					{
						$abonnes_id[] = $row['abo_id']; 
					}
					
					$sql = "SELECT abo_id 
						FROM " . ABO_LISTE_TABLE . " 
						GROUP BY abo_id"; 
					if( !($result = $db->query($sql)) )
					{
						msg_result($sql, true); 
					}
					
					$abo_liste_id = array(); 
					while( $row = $db->fetch_array($result) )
					{
						$abo_liste_id[] = $row['abo_id']; 
					}
					
					$diff_1 = array_diff($abonnes_id, $abo_liste_id); 
					$diff_2 = array_diff($abo_liste_id, $abonnes_id); 
					
					$total_diff_1 = count($diff_1); 
					$total_diff_2 = count($diff_2); 
					
					if( $total_diff_1 > 0 )
					{
						$sql_update[] = "DELETE FROM " . ABONNES_TABLE . " 
							WHERE abo_id IN(" . implode(', ', $diff_1) . ")"; 
					}
					
					if( $total_diff_2 > 0 )
					{
						$sql_update[] = "DELETE FROM " . ABO_LISTE_TABLE . " 
							WHERE abo_id IN(" . implode(', ', $diff_2) . ")"; 
					}
					
					switch( DATABASE )
					{
						case 'mssql':
							$sql_update[] = "ALTER TABLE " . LISTE_TABLE . " ADD 
								liste_numlogs smallint NOT NULL, 
								CONSTRAINT [DF_" . LISTE_TABLE . "_liste_numlogs] DEFAULT (0) FOR [liste_numlogs]"; 
							$sql_update[] = "ALTER TABLE " . LOG_TABLE . " ADD 
								log_numdest smallint NOT NULL, 
								CONSTRAINT [DF_" . LOG_TABLE . "_log_numdest] DEFAULT (0) FOR [log_numdest]"; 
							$sql_update[] = "ALTER TABLE " . CONFIG_TABLE . " ADD 
								check_email_mx smallint NOT NULL, 
								CONSTRAINT [DF_" . CONFIG_TABLE . "_check_email_mx] DEFAULT (0) FOR [check_email_mx]"; 
							$sql_update[] = "DROP INDEX " . ABO_LISTE_TABLE . ".IX_" . ABO_LISTE_TABLE; 
							$sql_update[] = "ALTER TABLE " . ABO_LISTE_TABLE . " ADD 
								CONSTRAINT [PK_" . ABO_LISTE_TABLE . "] PRIMARY KEY CLUSTERED ([abo_id], [liste_id]) ON [PRIMARY]"; 
							$sql_update[] = "DROP INDEX " . LOG_FILES_TABLE . ".IX_" . LOG_FILES_TABLE; 
							$sql_update[] = "ALTER TABLE " . LOG_FILES_TABLE . " ADD 
								CONSTRAINT [PK_" . LOG_FILES_TABLE . "] PRIMARY KEY CLUSTERED ([log_id], [file_id]) ON [PRIMARY]"; 
							break;
						
						case 'postgre':
							$sql_update[] = "ALTER TABLE " . LISTE_TABLE . " 
								ADD COLUMN liste_numlogs int2 NOT NULL"; 
							$sql_update[] = "ALTER TABLE " . LISTE_TABLE . " 
								ALTER COLUMN liste_numlogs SET DEFAULT '0'"; 
							$sql_update[] = "ALTER TABLE " . LOG_TABLE . " 
								ADD COLUMN log_numdest int2 NOT NULL"; 
							$sql_update[] = "ALTER TABLE " . LOG_TABLE . " 
								ALTER COLUMN log_numdest SET DEFAULT '0'"; 
							$sql_update[] = "ALTER TABLE " . CONFIG_TABLE . " 
								ADD COLUMN check_email_mx int NOT NULL"; 
							$sql_update[] = "ALTER TABLE " . CONFIG_TABLE . " 
								ALTER COLUMN check_email_mx SET DEFAULT '0'"; 
							break;
						
						default:
							$sql_update[] = "ALTER TABLE " . LISTE_TABLE . " 
								ADD COLUMN liste_numlogs smallint(5) NOT NULL DEFAULT '0' AFTER liste_alias"; 
							$sql_update[] = "ALTER TABLE " . LOG_TABLE . " 
								ADD COLUMN log_numdest smallint(5) NOT NULL DEFAULT '0' AFTER log_date"; 
							$sql_update[] = "ALTER TABLE " . CONFIG_TABLE . " 
								ADD COLUMN check_email_mx tinyint(1) NOT NULL DEFAULT '0' AFTER gd_img_type"; 
							$sql_update[] = "ALTER TABLE " . ABO_LISTE_TABLE . " DROP INDEX `abo_id`"; 
							$sql_update[] = "ALTER TABLE " . ABO_LISTE_TABLE . " DROP INDEX `liste_id`"; 
							$sql_update[] = "ALTER TABLE " . ABO_LISTE_TABLE . " 
								ADD PRIMARY KEY (abo_id , liste_id)"; 
							$sql_update[] = "ALTER TABLE " . LOG_FILES_TABLE . " DROP INDEX `log_id`"; 
							$sql_update[] = "ALTER TABLE " . LOG_FILES_TABLE . " DROP INDEX `file_id`"; 
							$sql_update[] = "ALTER TABLE " . LOG_FILES_TABLE . " 
								ADD PRIMARY KEY (log_id , file_id)"; 
							break;
					}
					
					$sql = "SELECT COUNT(*) AS numlogs, liste_id 
						FROM " . LOG_TABLE . " 
						WHERE log_status = " . STATUS_SENDED . " 
						GROUP BY liste_id"; 
					if( !($result = $db->query($sql)) )
					{
						msg_result($sql, true); 
					}
					
					while( $row = $db->fetch_array($result) )
					{
						$sql_update[] = "UPDATE " . LISTE_TABLE . " 
							SET liste_numlogs = " . $row['numlogs'] . " 
							WHERE liste_id = " . $row['liste_id']; 
					}
					
					$sql = "SELECT COUNT(DISTINCT(a.abo_id)) AS num_dest, al.liste_id 
						FROM " . ABONNES_TABLE . " AS a, " . ABO_LISTE_TABLE . " AS al 
						WHERE a.abo_id = al.abo_id AND a.abo_status = " . ABO_ACTIF . " 
						GROUP BY al.liste_id"; 
					if( !($result = $db->query($sql)) )
					{
						msg_result($sql, true); 
					}
					
					while( $row = $db->fetch_array($result) )
					{
						$sql_update[] = "UPDATE " . LOG_TABLE . " 
							SET log_numdest = " . $row['num_dest'] . " 
							WHERE liste_id = " . $row['liste_id']; 
					}
					break;
				
				default:
					msg_result($lang['Update_not_required']); 
					break;
			}
			
			$sql_update[] = "UPDATE " . CONFIG_TABLE . " SET version = '$new_version'"; 
			
			exec_queries($sql_update, true); 
		}// end if update
		
		$db->close_connexion();	
		
		if( !$error )
		{
			$l_title = ( $type == 'install' || $type == 'reinstall' ) ? $lang['Result_install'] : $lang['Result_update']; 
			
			if( $type == 'install' )
			{
				@chmod($waroot . 'includes/config.inc.php', 0666); 
				
				if( !($fw = @fopen($waroot . 'includes/config.inc.php', 'w')) )
				{
					$s_hidden_fields  = '<input type="hidden" name="dbtype" value="' . $dbtype . '" />'; 
					$s_hidden_fields .= '<input type="hidden" name="dbhost" value="' . $dbhost . '" />'; 
					$s_hidden_fields .= '<input type="hidden" name="dbuser" value="' . $dbuser . '" />'; 
					$s_hidden_fields .= '<input type="hidden" name="dbpassword" value="' . $dbpassword . '" />'; 
					$s_hidden_fields .= '<input type="hidden" name="dbname" value="' . $dbname . '" />'; 
					$s_hidden_fields .= '<input type="hidden" name="prefixe" value="' . $prefixe . '" />'; 
					
					$template->assign_block_vars('download_file', array(
						'L_TITLE'	  	  => $l_title,
						'L_DL_BUTTON' 	  => $lang['Button']['dl'],
						
						'MSG_RESULT'  	  => nl2br($lang['Success_whithout_config']),						
						'S_HIDDEN_FIELDS' => $s_hidden_fields
					));
					
					$template->pparse('body'); 
					exit;
				}
				
				fwrite($fw, $config_file);
				fclose($fw);
				
				@chmod($waroot . 'includes/config.inc.php', 0644); 
			}
			
			$msg_result = ( $type == 'install' || $type == 'reinstall' ) ? $lang['Success_install'] : $lang['Success_update']; 
			
			$template->assign_block_vars('result', array(
				'L_TITLE'	 => $l_title,
				'MSG_RESULT' => nl2br(sprintf($msg_result, '<a href="' . $waroot . 'admin/login.php">', '</a>'))
			));
			
			$template->pparse('body'); 
			exit;
		}
	}
	
	include($waroot . 'includes/functions.box.php'); 
	$lang_box = lang_box($language); 
	
	$lg = strtolower(substr($language, 0, 2)); 
	if( $lg != 'fr' && $lg != 'en' )
	{
		$lg = 'en'; 
	}
	
	$db_box = '<select name="dbtype">'; 
	foreach( $supported_db AS $db_name => $db_infos )
	{
		$selected = ( $dbtype == $db_name ) ? ' selected="selected"' : ''; 
		$db_box .= '<option value="' . $db_name . '"' . $selected . '> - ' . $db_infos['Name'] . ' - </option>'; 
	}
	$db_box .= '</select>'; 
	
	if( $urlsite == '' )
	{
		$urlsite = ( !empty($_SERVER['HTTP_HOST']) ) ? 'http://' . $_SERVER['HTTP_HOST'] : ''; 
	}
	
	if( $urlscript == '' )
	{
		$urlscript = ( !empty($_SERVER['PHP_SELF']) ) ? preg_replace('/^(.*?)\/setup\/?$/i', '\\1/', dirname($_SERVER['PHP_SELF'])) : ''; 
	}
	
	$template->assign_block_vars('welcome', array(
		'L_WELCOME'			=> nl2br( sprintf($lang['Welcome_in_install'], '<a href="' . $waroot . 'docs/readme_' . $lg . '.html" target="_blank">', '</a>')), 
		'TITLE_DATABASE'	=> $lang['Title']['database'],
		'TITLE_ADMIN'		=> $lang['Title']['admin'],
		'TITLE_DIVERS'		=> $lang['Title']['config_divers'],
		'L_DBTYPE'			=> $lang['dbtype'],
		'L_DBHOST'			=> $lang['dbhost'],
		'L_DBNAME'			=> $lang['dbname'],
		'L_DBUSER'			=> $lang['dbuser'],
		'L_DBPWD'			=> $lang['dbpwd'],
		'L_PREFIXE'			=> $lang['prefixe'],
		'L_DEFAULT_LANG'	=> $lang['Default_lang'],
		'L_LOGIN'			=> $lang['Login'],
		'L_PASS'			=> $lang['Password'],
		'L_PASS_CONF'		=> $lang['Conf_pass'],
		'L_EMAIL'			=> $lang['Email_address'],
		'L_URLSITE'			=> $lang['Urlsite'],
		'L_URLSCRIPT'		=> $lang['Urlscript'],
		'L_URLSITE_NOTE'	=> $lang['Urlsite_note'],
		'L_URLSCRIPT_NOTE'	=> $lang['Urlscript_note'],
		'L_BUTTON_START'	=> $lang['Start_install'],
		
		'DB_BOX'			=> $db_box,
		'DBHOST'			=> htmlspecialchars(stripslashes($dbhost)),
		'DBNAME'			=> htmlspecialchars(stripslashes($dbname)),
		'DBUSER'			=> htmlspecialchars(stripslashes($dbuser)),
		'DBPWD'				=> htmlspecialchars(stripslashes($dbpassword)),
		'PREFIXE'			=> htmlspecialchars(stripslashes($prefixe)),
		'LOGIN'				=> htmlspecialchars(stripslashes($admin_login)),
		'EMAIL'				=> htmlspecialchars(stripslashes($admin_email)),
		'URLSITE'			=> htmlspecialchars(stripslashes($urlsite)),
		'URLSCRIPT'			=> htmlspecialchars(stripslashes($urlscript)),
		
		'LANG_BOX'			=> $lang_box,
		'S_HIDDEN_FIELD'	=> '<input type="hidden" name="prev_language" value="' . $language .'" />'
	)); 
	
	if( $error )
	{
		$template->assign_block_vars('welcome.error', array(
			'MSG_ERROR' => '<br /><ul type="square" class="mediumtexte"><li>' . implode('</li><li>', $msg_error) . '</li></ul>'
		)); 
	}
}

$template->pparse('body'); 
?>